package dev.pfaff.altargui.render;

import dev.pfaff.altargui.internal.util.Specialize;

public abstract sealed class Uploadable permits RenderObject {
	/**
	 * The number of bytes that this consumer will provide the sink with upon {@link #uploadTo(Sink)}.
	 */
	public abstract int size();

	public abstract void uploadTo(Sink sink);

	@Specialize
	public void uSpecUploadAtUnchecked(ViaIntermediateBuffer buffer, long offset) {
		buffer.iSpecUploadAtUnchecked(offset, this);
	}
}
